#include <sstream>
#include "Pathfinder.h"

class MultipleTrees: public Pathfinder {
public:
	void preprocess(std::vector<int> &map, int width, int height);
	void findPath(Position start, Position goal, std::vector<Position> &path,
			std::vector<int> &map, int width, int height);

	void clear(){
		parents.clear();
	}

	std::string getName(){
		return name;
	}

	size_t getSize(){
		size_t size = 0;
		for(auto tree : parents){
			size += tree.size();
		}
		return size * sizeof(std::pair<double, int>);
	}

	MultipleTrees(int nRoots) :
			nRoots(nRoots){
		std::stringstream stream;
		stream << "MultipleTrees" << nRoots;
		name = stream.str();
	}

private:
	std::vector<std::vector<std::pair<double, int> > > parents;
	int nRoots;
	std::string name;
};
