#include "Heuristic.h"
#include "Pathfinder.h"
#include <cstdlib>

class OctileHeuristic: public Heuristic {
public:
	void preprocess(std::vector<int> &map, int width, int height, std::vector<Position> &roots){
		mapWidth = width;
	}

	double getValue(int nIndex, int gIndex){
		Position nPos = Position::fromIndex(nIndex, mapWidth);
		Position gPos = Position::fromIndex(gIndex, mapWidth);
		int dx = abs(nPos.x - gPos.x);
		int dy = abs(nPos.y - gPos.y);
		//max(x, y) + (sqrt(2)-1)*min(x, y)
		if(dx > dy){
			return dx + (DIAG_DIST-1)*dy;
		} else {
			return dy + (DIAG_DIST-1)*dx;
		}
	}

	void clear(){
		//nothing to do here
	}

	std::string getName(){
		return "Octile Heuristic";
	}

	size_t getSize(){
		return sizeof(int);
	}

private:
	int mapWidth;
};
